// This class represents a tree of integers
public class IntTree {
    private IntTreeNode overallRoot;

    // Constructs the tree shown
    public IntTree() {
        overallRoot = null;
    }
    
    public IntTree(int[] values) {
        overallRoot = constructorHelper(values, 0);
    }
    private IntTreeNode constructorHelper(int[] values, int i) {
        if (i < values.length) {
            IntTreeNode root = new IntTreeNode(values[i]);
            root.left = constructorHelper(values, i*2 + 1);
            root.right = constructorHelper(values, i*2 + 2);
            return root;
        } else {
            return null;
        }
    }

    public int size() {
        return size(overallRoot);
    }

    private int size(IntTreeNode root) {
        if (root == null) {
            return 0;
        } else {
            return 1 + size(root.left) + size(root.right);
        }
    }

    // prints out all data contained in the tree on a single line
    // based on a preorder traversal sequence
    public void preOrderTraversal() {
        /* YOUR CODE */
    }

    // prints out all data contained in the tree on a single line
    // based on an inorder traversal sequence
    public void inOrderTraversal() {
        /* YOUR CODE */
    }

    // prints out all data contained in the tree on a single line
    // based on a postorder traversal sequence
    public void postOrderTraversal() {
        /* YOUR CODE */
    }    

    // prints out all data contained in the tree, comma separated
    // using paranthesis to surround each sub tree 
    // print "empty" for any missing children nodes
    // ex: (6, (3, 1, 4), (2, 6, 4))
    public void toString() {
        /* YOUR CODE HERE */
    }

    // Class that represents a single node in the tree
    private static class IntTreeNode {
        public int data; // data stored at this node
        public IntTreeNode left; // reference to left subtree
        public IntTreeNode right; // reference to right subtree

        // Constructs a leaf node with the given data.
        public IntTreeNode(int data) {
            this(data, null, null);
        }

        // Constructs a leaf or branch node with the given data and links.
        public IntTreeNode(int data, IntTreeNode left, IntTreeNode right) {
            this.data = data;
            this.left = left;
            this.right = right;
        }
    }
}
